{-# LANGUAGE ForeignFunctionInterface #-}

-- module HROOT.Class.FFI where

module HROOT.Class.TROOT.FFI where


import Foreign.C            
import Foreign.Ptr

-- import HROOT.Class.Interface

-- #include ""

import HROOT.Class.TROOT.RawType
import HROOT.Class.TObject.RawType
import HROOT.Class.TKey.RawType
import HROOT.Class.TClass.RawType
import HROOT.Class.TSeqCollection.RawType
import HROOT.Class.TCollection.RawType

#include "HROOTTROOT.h"

foreign import ccall "HROOTTROOT.h TROOT_Append" c_troot_append 
  :: (Ptr RawTROOT) -> (Ptr RawTObject) -> CInt -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_addD" c_troot_addd 
  :: (Ptr RawTROOT) -> (Ptr RawTObject) -> CInt -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_AppendKey" c_troot_appendkey 
  :: (Ptr RawTROOT) -> (Ptr RawTKey) -> IO CInt
foreign import ccall "HROOTTROOT.h TROOT_Close" c_troot_close 
  :: (Ptr RawTROOT) -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_Get" c_troot_get 
  :: (Ptr RawTROOT) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTROOT.h TROOT_SetName" c_troot_setname 
  :: (Ptr RawTROOT) -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_SetNameTitle" c_troot_setnametitle 
  :: (Ptr RawTROOT) -> CString -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_SetTitle" c_troot_settitle 
  :: (Ptr RawTROOT) -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_Draw" c_troot_draw 
  :: (Ptr RawTROOT) -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_FindObject" c_troot_findobject 
  :: (Ptr RawTROOT) -> CString -> IO (Ptr RawTObject)
foreign import ccall "HROOTTROOT.h TROOT_GetName" c_troot_getname 
  :: (Ptr RawTROOT) -> IO CString
foreign import ccall "HROOTTROOT.h TROOT_IsA" c_troot_isa 
  :: (Ptr RawTROOT) -> IO (Ptr RawTClass)
foreign import ccall "HROOTTROOT.h TROOT_IsFolder" c_troot_isfolder 
  :: (Ptr RawTROOT) -> IO CInt
foreign import ccall "HROOTTROOT.h TROOT_IsEqual" c_troot_isequal 
  :: (Ptr RawTROOT) -> (Ptr RawTObject) -> IO CInt
foreign import ccall "HROOTTROOT.h TROOT_IsSortable" c_troot_issortable 
  :: (Ptr RawTROOT) -> IO CInt
foreign import ccall "HROOTTROOT.h TROOT_Paint" c_troot_paint 
  :: (Ptr RawTROOT) -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_printObj" c_troot_printobj 
  :: (Ptr RawTROOT) -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_RecursiveRemove" c_troot_recursiveremove 
  :: (Ptr RawTROOT) -> (Ptr RawTObject) -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_SaveAs" c_troot_saveas 
  :: (Ptr RawTROOT) -> CString -> CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_UseCurrentStyle" c_troot_usecurrentstyle 
  :: (Ptr RawTROOT) -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_Write" c_troot_write 
  :: (Ptr RawTROOT) -> CString -> CInt -> CInt -> IO CInt
foreign import ccall "HROOTTROOT.h TROOT_delete" c_troot_delete 
  :: (Ptr RawTROOT) -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfColors" c_troot_trootgetlistofcolors 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfTypes" c_troot_trootgetlistoftypes 
  :: (Ptr RawTROOT) -> CInt -> IO (Ptr RawTCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfGlobals" c_troot_trootgetlistofglobals 
  :: (Ptr RawTROOT) -> CInt -> IO (Ptr RawTCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfGlobalFunctions" c_troot_trootgetlistofglobalfunctions 
  :: (Ptr RawTROOT) -> CInt -> IO (Ptr RawTCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfClosedObjects" c_troot_trootgetlistofclosedobjects 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfFiles" c_troot_trootgetlistoffiles 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfMappedFiles" c_troot_trootgetlistofmappedfiles 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfSockets" c_troot_trootgetlistofsockets 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfCanvases" c_troot_trootgetlistofcanvases 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfStyles" c_troot_trootgetlistofstyles 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfFunctions" c_troot_trootgetlistoffunctions 
  :: (Ptr RawTROOT) -> IO (Ptr RawTCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfGeometries" c_troot_trootgetlistofgeometries 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfBrowsers" c_troot_trootgetlistofbrowsers 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfSpecials" c_troot_trootgetlistofspecials 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfTasks" c_troot_trootgetlistoftasks 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfCleanups" c_troot_trootgetlistofcleanups 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetListOfStreamerInfo" c_troot_trootgetlistofstreamerinfo 
  :: (Ptr RawTROOT) -> IO (Ptr RawTSeqCollection)
foreign import ccall "HROOTTROOT.h TROOT_tROOTDecreaseDirLevel" c_troot_trootdecreasedirlevel 
  :: IO CInt
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetDirLevel" c_troot_trootgetdirlevel 
  :: IO CInt
foreign import ccall "HROOTTROOT.h TROOT_tROOTGetMacroPath" c_troot_trootgetmacropath 
  :: IO CString
foreign import ccall "HROOTTROOT.h TROOT_tROOTSetMacroPath" c_troot_trootsetmacropath 
  :: CString -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_tROOTIncreaseDirLevel" c_troot_trootincreasedirlevel 
  :: IO CInt
foreign import ccall "HROOTTROOT.h TROOT_tROOTIndentLevel" c_troot_trootindentlevel 
  :: IO ()
foreign import ccall "HROOTTROOT.h TROOT_tROOTInitialized" c_troot_trootinitialized 
  :: IO CInt
foreign import ccall "HROOTTROOT.h TROOT_tROOTMemCheck" c_troot_trootmemcheck 
  :: IO CInt
foreign import ccall "HROOTTROOT.h TROOT_tROOTSetDirLevel" c_troot_trootsetdirlevel 
  :: CInt -> IO ()
foreign import ccall "HROOTTROOT.h TROOT_tROOTConvertVersionCode2Int" c_troot_trootconvertversioncode2int 
  :: CInt -> IO CInt
foreign import ccall "HROOTTROOT.h TROOT_tROOTConvertVersionInt2Code" c_troot_trootconvertversionint2code 
  :: CInt -> IO CInt
foreign import ccall "HROOTTROOT.h TROOT_tROOTRootVersionCode" c_troot_trootrootversioncode 
  :: IO CInt

